VERSION 5.00
Begin VB.UserControl LED 
   BackStyle       =   0  'Transparent
   ClientHeight    =   1755
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1350
   PropertyPages   =   "LED.ctx":0000
   ScaleHeight     =   1755
   ScaleWidth      =   1350
   ToolboxBitmap   =   "LED.ctx":0024
   Begin VB.Shape shpDecimal 
      FillStyle       =   0  'Solid
      Height          =   255
      Left            =   960
      Shape           =   3  'Circle
      Top             =   1320
      Width           =   255
   End
   Begin VB.Line linSegment 
      Index           =   6
      X1              =   840
      X2              =   840
      Y1              =   840
      Y2              =   1440
   End
   Begin VB.Line linSegment 
      Index           =   5
      X1              =   120
      X2              =   120
      Y1              =   960
      Y2              =   1440
   End
   Begin VB.Line linSegment 
      Index           =   4
      X1              =   840
      X2              =   840
      Y1              =   240
      Y2              =   720
   End
   Begin VB.Line linSegment 
      Index           =   3
      X1              =   120
      X2              =   120
      Y1              =   240
      Y2              =   720
   End
   Begin VB.Line linSegment 
      Index           =   2
      X1              =   240
      X2              =   720
      Y1              =   1560
      Y2              =   1560
   End
   Begin VB.Line linSegment 
      Index           =   1
      X1              =   240
      X2              =   600
      Y1              =   840
      Y2              =   840
   End
   Begin VB.Line linSegment 
      Index           =   0
      X1              =   240
      X2              =   720
      Y1              =   120
      Y2              =   120
   End
End
Attribute VB_Name = "LED"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
' ------------------------------------------------------------------------
'      Copyright  1997 Microsoft Corporation.  All rights reserved.
'
' You have a royalty-free right to use, modify, reproduce and distribute
' the Sample Application Files (and/or any modified version) in any way
' you find useful, provided that you agree that Microsoft has no warranty,
' obligations or liability for any Sample Application Files.
' ------------------------------------------------------------------------

Option Explicit

'   Enum for Errors
    Public Enum LEDErrorType
        LEDOverFlow = 100
        LEDInvalidMask = 200
    End Enum 'LEDErrorType
    
'   Enum for BackStyle
    Public Enum BackStyleType
        Transparent = 0
        Opaque
    End Enum 'BackStyleType

'   Default Property Values:
    Private Const m_def_Value = 0
    Private Const m_def_ValueIsMask = False
    Private Const m_def_ShowDecimal = False
    Private Const m_def_LEDColorOn = 255
    Private Const m_def_LEDColorOff = 0
    Private Const m_def_ShowBorder = False

'   Property Variables:
    Dim m_Value         As Integer      'Value to display on LED
    Dim m_ValueIsMask   As Boolean      'Flag to show if value is a mask
    Dim m_ShowDecimal   As Boolean      'Flag to show decimal
    Dim m_ShowBorder    As Boolean      'Flag to show control border
    Dim m_LEDColorOn    As OLE_COLOR    'Color of "on" segments
    Dim m_LEDColorOff   As OLE_COLOR    'Color of "off" segments
    
'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_Value = m_def_Value
    m_ValueIsMask = m_def_ValueIsMask
    m_ShowDecimal = m_def_ShowDecimal
    m_ShowBorder = m_def_ShowBorder
    m_LEDColorOn = m_def_LEDColorOn
    m_LEDColorOff = m_def_LEDColorOff
    
    UpdateLED
    UpdateDecimal
End Sub

Private Sub UserControl_Resize()
'   Use static, not to maintain values, but to reduce the amount of initialization
    Static Border As Integer
    Static Offset As Integer
    Static tWidth As Integer
    Static I As Integer
    
'   Assign values based on if form is wider than it is taller, etc....
    If ScaleWidth > ScaleHeight Then
        Border = ScaleHeight * 0.075
        Offset = ScaleHeight * 0.1
        tWidth = ScaleHeight * 0.15
    Else
        Border = ScaleWidth * 0.075
        Offset = ScaleWidth * 0.1
        tWidth = ScaleWidth * 0.15
    End If

'   Set the decimal point
    shpDecimal.Move ScaleWidth - Border - tWidth, ScaleHeight - Border - tWidth, tWidth, tWidth

'   Set the segment width
    For I = 0 To 6
        linSegment(I).BorderWidth = tWidth * 0.05
    Next I
    
'   Relocate all of the segments
    With linSegment(0)
        .X1 = Border + Offset
        .Y1 = Border
        .X2 = ScaleWidth - 3 * Border - tWidth - Offset
        .Y2 = Border
    End With 'linSegment(0)
    
    With linSegment(1)
        .X1 = Border + Offset
        .Y1 = ScaleHeight / 2
        .X2 = ScaleWidth - 3 * Border - tWidth - Offset
        .Y2 = ScaleHeight / 2
    End With 'linSegment(1)
    
    With linSegment(2)
        .X1 = Border + Offset
        .Y1 = ScaleHeight - Border
        .X2 = ScaleWidth - 3 * Border - tWidth - Offset
        .Y2 = ScaleHeight - Border
    End With 'linSegment(2)
    
    With linSegment(3)
        .X1 = Border
        .Y1 = Border + Offset
        .X2 = Border
        .Y2 = ScaleHeight / 2 - Offset
    End With 'linSegment(3)
    
    With linSegment(4)
        .X1 = ScaleWidth - 3 * Border - tWidth
        .Y1 = Border + Offset
        .X2 = ScaleWidth - 3 * Border - tWidth
        .Y2 = ScaleHeight / 2 - Offset
    End With 'linSegment(4)
    
    With linSegment(5)
        .X1 = Border
        .Y1 = ScaleHeight / 2 + Offset
        .X2 = Border
        .Y2 = ScaleHeight - Border - Offset
    End With 'linSegment(5)
    
    With linSegment(6)
        .X1 = ScaleWidth - 3 * Border - tWidth
        .Y1 = ScaleHeight / 2 + Offset
        .X2 = ScaleWidth - 3 * Border - tWidth
        .Y2 = ScaleHeight - Border - Offset
    End With 'linSegment(6)
    
'   Needed to deal with the unresolved bug related to adding user controls
    DoEvents
End Sub

Public Property Get Value() As Integer
Attribute Value.VB_ProcData.VB_Invoke_Property = "LEDProperties"
    Value = m_Value
End Property

Public Property Let Value(ByVal New_Value As Integer)
    If Not ValueIsMask Then
        If New_Value < 0 Or New_Value > 9 Then
            LEDError (LEDOverFlow)
            New_Value = 0
        End If
    Else
        If New_Value < 0 Or New_Value > 127 Then
            LEDError (LEDInvalidMask)
            New_Value = 0
        End If
    End If
    
    m_Value = New_Value
    PropertyChanged "Value"
    
    UpdateLED
End Property

Public Property Get ValueIsMask() As Boolean
    ValueIsMask = m_ValueIsMask
End Property

Public Property Let ValueIsMask(ByVal New_ValueIsMask As Boolean)
    If New_ValueIsMask <> m_ValueIsMask Then
        m_ValueIsMask = New_ValueIsMask
        PropertyChanged "ValueIsMask"
            
        UpdateLED
    End If
End Property

Public Property Get ShowDecimal() As Boolean
    ShowDecimal = m_ShowDecimal
End Property

Public Property Let ShowDecimal(ByVal New_ShowDecimal As Boolean)
    m_ShowDecimal = New_ShowDecimal
    PropertyChanged "ShowDecimal"
    
    UpdateDecimal
End Property

Public Property Get ShowBorder() As Boolean
    ShowBorder = m_ShowBorder
End Property

Public Property Let ShowBorder(ByVal New_ShowBorder As Boolean)
    m_ShowBorder = New_ShowBorder
    
    If m_ShowBorder Then
        BorderStyle = 1
    Else
        BorderStyle = 0
    End If
    
    PropertyChanged "ShowBorder"
End Property

Public Property Get LEDColorOn() As OLE_COLOR
    LEDColorOn = m_LEDColorOn
End Property

Public Property Let LEDColorOn(ByVal New_LEDColorOn As OLE_COLOR)
    m_LEDColorOn = New_LEDColorOn
    PropertyChanged "LEDColorOn"
    
    UpdateLED
    UpdateDecimal
End Property

Public Property Get LEDColorOff() As OLE_COLOR
    LEDColorOff = m_LEDColorOff
End Property

Public Property Let LEDColorOff(ByVal New_LEDColorOff As OLE_COLOR)
    m_LEDColorOff = New_LEDColorOff
    PropertyChanged "LEDColorOff"
    
    UpdateLED
    UpdateDecimal
End Property

Public Property Get BackStyle() As BackStyleType
    BackStyle = UserControl.BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As BackStyleType)
    UserControl.BackStyle() = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Value = PropBag.ReadProperty("Value", m_def_Value)
    ValueIsMask = PropBag.ReadProperty("ValueIsMask", m_def_ValueIsMask)
    ShowDecimal = PropBag.ReadProperty("ShowDecimal", m_def_ShowDecimal)
    LEDColorOn = PropBag.ReadProperty("LEDColorOn", m_def_LEDColorOn)
    LEDColorOff = PropBag.ReadProperty("LEDColorOff", m_def_LEDColorOff)
    ShowBorder = PropBag.ReadProperty("ShowBorder", m_def_ShowBorder)
    UserControl.BackStyle = PropBag.ReadProperty("BackStyle", 0)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Value", m_Value, m_def_Value)
    Call PropBag.WriteProperty("ShowDecimal", m_ShowDecimal, m_def_ShowDecimal)
    Call PropBag.WriteProperty("LEDColorOn", m_LEDColorOn, m_def_LEDColorOn)
    Call PropBag.WriteProperty("LEDColorOff", m_LEDColorOff, m_def_LEDColorOff)
    Call PropBag.WriteProperty("ShowBorder", m_ShowBorder, m_def_ShowBorder)
    Call PropBag.WriteProperty("BackStyle", UserControl.BackStyle, 0)
    Call PropBag.WriteProperty("ValueIsMask", m_ValueIsMask, m_def_ValueIsMask)
End Sub

Private Sub UpdateLED()
    Dim m_Mask As Integer
    Dim I As Integer
    
'   Get the m_Mask for the correct display type
    If Not ValueIsMask Then
        m_Mask = GetMaskValue
    Else
        m_Mask = m_Value
    End If
        
'   Turn on the segments, based on the mask
    For I = 0 To 6
        If ((m_Mask And 2 ^ I) = 2 ^ I) Then
            linSegment(I).BorderColor = m_LEDColorOn
        Else
            linSegment(I).BorderColor = m_LEDColorOff
        End If
    Next I
End Sub

Private Sub UpdateDecimal()
'   Show the decimal, if it is selected
    If m_ShowDecimal Then
        shpDecimal.FillColor = m_LEDColorOn
        shpDecimal.BorderColor = m_LEDColorOn
    Else
        shpDecimal.FillColor = m_LEDColorOff
        shpDecimal.BorderColor = m_LEDColorOff
    End If
End Sub

Private Function GetMaskValue() As Integer
    Select Case m_Value
        Case 0: GetMaskValue = 125
        Case 1: GetMaskValue = 80
        Case 2: GetMaskValue = 55
        Case 3: GetMaskValue = 87
        Case 4: GetMaskValue = 90
        Case 5: GetMaskValue = 79
        Case 6: GetMaskValue = 111
        Case 7: GetMaskValue = 81
        Case 8: GetMaskValue = 127
        Case 9: GetMaskValue = 95
    End Select 'm_Value
End Function

Private Sub LEDError(ByVal ErrNum As Long)
    Dim lMsg As String
    
    Select Case ErrNum
        Case LEDOverFlow
            lMsg = LoadResString(LEDOverFlow)
        Case LEDInvalidMask
            lMsg = LoadResString(LEDInvalidMask)
        Case Else
            lMsg = "Unknown Error!"
    End Select 'ErrNum
    
    If Ambient.UserMode Then
'       Run time
        Err.Raise vbObjectError Or ErrNum, , lMsg
    Else
'       Design time
        MsgBox lMsg, vbExclamation Or vbOKOnly, "LED Error"
    End If
End Sub
